PGOBLIN_BANG(-f)
--# Copyright (C) @BABOLO  2008 http://www.babolo.ru/
--# All rights reserved.
--#
--# Redistribution and use in source and binary forms, with or without
--# modification, are permitted provided that the following conditions
--# are met:
--# 1. Redistributions of source code must retain the above copyright
--#    notice, this list of conditions and the following disclaimer.
--# 2. Redistributions in binary form must reproduce the above copyright
--#    notice, this list of conditions and the following disclaimer in the
--#    documentation and/or other materials provided with the distribution.
--#
--# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
--# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
--# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
--# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
--# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
--# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
--# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
--# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
--# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
--# SUCH DAMAGE.
--#
--# $Id: CIPA_1.m4,v 1.4 2009/07/03 14:44:17 babolo Exp $

#connect 0001
DBMS
GETARG(,1)
GETENV(,1)
#perform 0001
CREATE TEMP TABLE x(dumpath text, db text);

INSERT INTO x(db) SELECT a FROM a WHERE i = 0 AND a REGEXP '^[a-z_][0-9a-z_]*$';
DELETE FROM x WHERE db IS NULL;
#select 2001
SELECT '#error
No DB name or illegal DB name
'WHERE (SELECT COUNT(*) FROM x) <> 1
#eval 02
#select 2001
SELECT 'pgsql dbname=' || db FROM x
#connect 02
#perform
--# CREATE FUNCTION plpgsql_call_handler() RETURNS language_handler
--#  AS '$libdir/plpgsql.so'
--#  LANGUAGE C
--# ;
--# CREATE TRUSTED PROCEDURAL LANGUAGE 'plpgsql' HANDLER plpgsql_call_handler;
CREATE LANGUAGE 'plpgsql';
INCLUDE_MODULE(5, pgcrypto)
--# INCLUDE_MODULE(5, misc_utils)
INCLUDE_MODULE(5, int_aggregate)
INCLUDE_MODULE(5, pglib_text)
INCLUDE_MODULE(5, pglib_ip)
INCLUDE_MODULE(5, pglib_bytea)
INCLUDE_MODULE(5, pglib_set)
INCLUDE_MODULE(5, pglib_bit)

#perform
CREATE TABLE "cipa cipa"
     ( cipanm text
     , cipaid int4
     , selflc int4
     , whom   name
     , period interval
     , strict bool
     , selfgr bool
     , cipadp varbit
     )
;
COMMENT ON TABLE "cipa cipa"       IS '  ';
COMMENT ON COLUMN "cipa cipa".cipanm IS '   ';
COMMENT ON COLUMN "cipa cipa".cipaid IS '  ';
COMMENT ON COLUMN "cipa cipa".selflc IS '  (NULL  , 0 -   , ...';
COMMENT ON COLUMN "cipa cipa".whom   IS '   ';
COMMENT ON COLUMN "cipa cipa".period IS ' ';
COMMENT ON COLUMN "cipa cipa".strict IS '   ';
COMMENT ON COLUMN "cipa cipa".selfgr IS '   ';
COMMENT ON COLUMN "cipa cipa".cipadp IS '  ( - )';
GRANT SELECT ON "cipa cipa" TO root;

#perform
CREATE TABLE "cipa in"
     ( cipaid int4
     , selflc int4
     , whom   name
     , period interval
     , strict bool
     , selfgr bool
     , cipadp varbit
     , plid   int8
     , loco   int8
     , ciparg text[]
     , pid    int4
     , plan   timestamp
     , deed   timestamp
     )
     WITHOUT OIDS
;
COMMENT ON TABLE "cipa in"         IS ' ';
COMMENT ON COLUMN "cipa in".cipaid   IS '  ';
COMMENT ON COLUMN "cipa in".selflc   IS '  (NULL  , 0 -   , ...';
COMMENT ON COLUMN "cipa in".whom     IS '   ';
COMMENT ON COLUMN "cipa in".period   IS ' ';
COMMENT ON COLUMN "cipa in".strict   IS '   ';
COMMENT ON COLUMN "cipa in".selfgr   IS '   ';
COMMENT ON COLUMN "cipa in".cipadp   IS '  ( - )';
COMMENT ON COLUMN "cipa in".plid     IS '   ';
COMMENT ON COLUMN "cipa in".loco     IS '  plid  ';
COMMENT ON COLUMN "cipa in".ciparg   IS '  plid';
COMMENT ON COLUMN "cipa in".pid      IS 'PID ';
COMMENT ON COLUMN "cipa in".plan     IS '  ';
COMMENT ON COLUMN "cipa in".deed     IS '  ';
GRANT SELECT, INSERT, UPDATE, DELETE ON "cipa in" TO root;

#perform
CREATE TABLE "cipa out"
     ( cipaid int4
     , whom   name
     , plid   int8
     , loco   int8
     , ciparg text[]
     , pid    int4
     , plan   timestamp
     , deed   timestamp
     , reed   timestamp
     )
     WITHOUT OIDS
;
COMMENT ON TABLE "cipa out"        IS ' ';
COMMENT ON COLUMN "cipa out".cipaid  IS '  ';
COMMENT ON COLUMN "cipa out".whom    IS '   ';
COMMENT ON COLUMN "cipa out".plid    IS '   ';
COMMENT ON COLUMN "cipa out".loco    IS '  plid  ';
COMMENT ON COLUMN "cipa out".ciparg  IS '  plid';
COMMENT ON COLUMN "cipa out".pid     IS 'PID ';
COMMENT ON COLUMN "cipa out".plan    IS '  ';
COMMENT ON COLUMN "cipa out".deed    IS '  ';
COMMENT ON COLUMN "cipa out".reed    IS '  ';
GRANT SELECT, INSERT ON "cipa out" TO root;

#perform
CREATE TABLE "cipa log"
     ( log   int8
     , toid  regclass
     , roid  oid
     , coid  tid
     , field varbit
     , link  int4
     , mess  text
     , whom  name
     , whon  timestamptz
     )
     WITHOUT OIDS
;
COMMENT ON TABLE "cipa log"        IS '    ';
COMMENT ON COLUMN "cipa log".log     IS '   ';
COMMENT ON COLUMN "cipa log".toid    IS 'oid ';
COMMENT ON COLUMN "cipa log".roid    IS 'oid ';
COMMENT ON COLUMN "cipa log".coid    IS 'ctid ';
COMMENT ON COLUMN "cipa log".field   IS '';
COMMENT ON COLUMN "cipa log".link    IS '   ';
COMMENT ON COLUMN "cipa log".mess    IS '';
COMMENT ON COLUMN "cipa log".whom    IS ' ';
COMMENT ON COLUMN "cipa log".whon    IS '  ';

#perform
CREATE TABLE "cipa ver"
     ( prog   text
     , major  int4
     , minor  int4
     )
     WITHOUT OIDS
;
COMMENT ON TABLE "cipa ver"        IS '   ';
COMMENT ON COLUMN "cipa ver".prog    IS '';
COMMENT ON COLUMN "cipa ver".major   IS '';
COMMENT ON COLUMN "cipa ver".minor   IS '';
GRANT SELECT ON "cipa ver" TO PUBLIC;

#perform
CREATE TABLE "cipa old"
     ( prog   text
     , major  int4
     , minor  int4
     )
     WITHOUT OIDS
;
COMMENT ON TABLE "cipa old"        IS '   ';
COMMENT ON COLUMN "cipa old".prog    IS '';
COMMENT ON COLUMN "cipa old".major   IS '';
COMMENT ON COLUMN "cipa old".minor   IS '';
GRANT SELECT ON "cipa old" TO PUBLIC;

#perform
CREATE TABLE "cipa dep"
     ( prog   text
     , dprog  text
     , dmajor int4
     , dminor int4
     )
     WITHOUT OIDS
;
COMMENT ON TABLE "cipa dep"        IS ' prog  dprog-dmajor.dminor';
COMMENT ON COLUMN "cipa dep".prog    IS '';
COMMENT ON COLUMN "cipa dep".dprog   IS '  ';
COMMENT ON COLUMN "cipa dep".dmajor  IS '  ';
COMMENT ON COLUMN "cipa dep".dminor  IS '  ';
GRANT SELECT ON "cipa dep" TO PUBLIC;

REGISTRY_VERSION
