PGOBLIN_BANG(-f)
--# Copyright (C) @BABOLO  2008 http://www.babolo.ru/
--# All rights reserved.
--#
--# Redistribution and use in source and binary forms, with or without
--# modification, are permitted provided that the following conditions
--# are met:
--# 1. Redistributions of source code must retain the above copyright
--#    notice, this list of conditions and the following disclaimer.
--# 2. Redistributions in binary form must reproduce the above copyright
--#    notice, this list of conditions and the following disclaimer in the
--#    documentation and/or other materials provided with the distribution.
--#
--# THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
--# ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
--# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
--# ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
--# FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
--# DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
--# OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
--# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
--# LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
--# OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
--# SUCH DAMAGE.
--#
--# $Id: CIPA_5.m4,v 1.4 2009/07/03 14:44:17 babolo Exp $

#connect 0001
DBMS
GETARG(,1)
#perform 0001
CREATE TEMP TABLE x(db text);

INSERT INTO x(db) SELECT a FROM a WHERE i = 0 AND a REGEXP '^[a-z_][0-9a-z_]*$';
DELETE FROM x WHERE db IS NULL;
#select 2001
SELECT '#error
No DB name or illegal DB name
'WHERE (SELECT COUNT(*) FROM x) <> 1
#eval 02
#select 2001
SELECT 'pgsql dbname=' || db FROM x;
#connect 02

#perform
SET_NOTNULL("cipa cipa", cipanm)
CREATE UNIQUE INDEX "cipa cipa pdx"    ON "cipa cipa"(cipanm);
ALTER TABLE ONLY "cipa cipa"    ADD PRIMARY KEY(cipaid);
#select 3
SELECT 'CREATE SEQUENCE "cipa&cipa&seq" MINVALUE 0 START '
     , COALESCE((SELECT MAX(cipaid) FROM "cipa cipa"), 0)
;
#perform 03
#perform
ALTER TABLE ONLY "cipa cipa"    ALTER cipaid  SET DEFAULT nextval('cipa&cipa&seq');

SET_NOTNULL("cipa out", cipaid, plan, reed)
ALTER TABLE ONLY "cipa out"     ADD PRIMARY KEY(plid);
ALTER TABLE ONLY "cipa out"     ADD FOREIGN KEY(cipaid)          REFERENCES "cipa cipa";
ALTER TABLE ONLY "cipa out"     ALTER reed    SET DEFAULT now();

SET_NOTNULL("cipa in", cipaid, plan)
ALTER TABLE ONLY "cipa in"      ADD PRIMARY KEY(plid);
#select 3
SELECT 'CREATE SEQUENCE "cipa&in&seq" MINVALUE 0 START '
     , COALESCE( (SELECT MAX(plid) FROM (SELECT MAX(plid) AS plid FROM "cipa in"
                                        UNION
                                         SELECT MAX(plid) AS plid FROM "cipa out"
                                        )t
                 )
               , 0
               ) + 1
;
#perform 03
#perform
ALTER TABLE ONLY "cipa in"      ADD FOREIGN KEY(cipaid)          REFERENCES "cipa cipa";
ALTER TABLE ONLY "cipa in"      ALTER plid    SET DEFAULT nextval('cipa&in&seq');
ALTER TABLE ONLY "cipa in"      ALTER plan    SET DEFAULT now();

SET_NOTNULL("cipa log", log, toid, whom, whon)
CREATE        INDEX "cipa log ndx"     ON "cipa log"(log);
CREATE UNIQUE INDEX "cipa log un"      ON "cipa log"(toid, roid);
#select 3
SELECT 'CREATE SEQUENCE "cipa&log&seq" MINVALUE 0 START '
     , COALESCE((SELECT MAX(log) + 1 FROM "cipa log"), 0)
;
#perform 03
#perform
ALTER TABLE ONLY "cipa log"     ALTER log     SET DEFAULT nextval('cipa&log&seq');
ALTER TABLE ONLY "cipa log"     ALTER whon    SET DEFAULT now();
#perform
CREATE VIEW "cipa"
 AS SELECT cipaid
         , "cipa in".plan
         , "cipa in".ciparg
         , "cipa in".loco
         , "cipa in".deed
         , "cipa in".pid
         , "cipa in".plid
         , COALESCE("cipa in".cipadp, "cipa cipa".cipadp, ''    ) AS cipadp
         , COALESCE("cipa in".selflc, "cipa cipa".selflc)         AS selflc
         , COALESCE("cipa in".selfgr, "cipa cipa".selfgr, FALSE)  AS selfgr
         , COALESCE("cipa in".whom  , "cipa cipa".whom  , 'cipa') AS whom
         , COALESCE("cipa in".strict, "cipa cipa".strict, FALSE ) AS strict
         , COALESCE("cipa in".period, "cipa cipa".period)         AS period
         , "cipa cipa".cipanm
     FROM  "cipa in"
      JOIN "cipa cipa" USING(cipaid)
        , (SELECT disjunction(COALESCE("cipa in".cipadp, "cipa cipa".cipadp)) AS cdp
            FROM "cipa in" JOIN "cipa cipa" USING(cipaid)
            WHERE pid IS NOT NULL
          )e
     WHERE COALESCE(NOT boolor(COALESCE("cipa in".cipadp, "cipa cipa".cipadp) /| e.cdp), TRUE)
       AND NOT EXISTS(SELECT 1
                       FROM (SELECT DISTINCT "cipa in".selflc
                                  , ciparg[1:COALESCE("cipa in".selflc, "cipa cipa".selflc)] AS ciparg
                              FROM "cipa in" JOIN "cipa cipa" USING(cipaid)
                              WHERE pid IS NOT NULL
                            )e
                       WHERE compare( CASE WHEN COALESCE("cipa in".selflc, "cipa cipa".selflc)
                                              > e.selflc
                                           THEN e.selflc
                                           ELSE COALESCE("cipa in".selflc, "cipa cipa".selflc)
                                      END
                                    , e.ciparg
                                    , "cipa in".ciparg
                     )              )
;
COMMENT ON VIEW "cipa"             IS ' ';
COMMENT ON COLUMN "cipa".cipaid      IS '  ';
COMMENT ON COLUMN "cipa".plan        IS '  ';
COMMENT ON COLUMN "cipa".ciparg      IS '  plid';
COMMENT ON COLUMN "cipa".loco        IS '  plid  ';
COMMENT ON COLUMN "cipa".selflc      IS '  (NULL  , 0 -   , ...';
COMMENT ON COLUMN "cipa".cipadp      IS '  ( - )';
COMMENT ON COLUMN "cipa".whom        IS '   ';
COMMENT ON COLUMN "cipa".plid        IS '   ';
COMMENT ON COLUMN "cipa".selfgr      IS '   ';
COMMENT ON COLUMN "cipa".strict      IS '   ';
COMMENT ON COLUMN "cipa".period      IS ' ';
COMMENT ON COLUMN "cipa".deed        IS '  ';
COMMENT ON COLUMN "cipa".pid         IS 'PID ';
COMMENT ON COLUMN "cipa".cipanm      IS '   ';
#perform
CREATE OR REPLACE RULE "cipa"
 AS ON INSERT TO "cipa"
 DO INSTEAD
  ( INSERT INTO "cipa in"(cipaid, plan, ciparg, loco, selflc, cipadp, whom, plid)
     SELECT NEW.cipaid
          , COALESCE(NEW.plan, now())
          , NEW.ciparg
          , NEW.loco
          , NEW.selflc
          , NEW.cipadp
          , CASE WHEN NEW.whom IS NOT NULL THEN session_user END
          , nextval('cipa&in&seq')
  )
;
GRANT SELECT, INSERT ON "cipa" TO root;
#perform
CREATE OR REPLACE FUNCTION cipa() RETURNS int8
 AS 'SELECT plid FROM cipa ORDER BY loco IS NULL, plan LIMIT 1' LANGUAGE SQL STABLE
;
COMMENT ON FUNCTION cipa()         IS ' plid  ';
#perform
CREATE OR REPLACE FUNCTION cipa(int8) RETURNS timestamp
 AS 'SELECT plan FROM "cipa in" WHERE plid = $1' LANGUAGE SQL STABLE
;
COMMENT ON FUNCTION cipa(int8)     IS '     plid';
#perform
CREATE OR REPLACE FUNCTION trunextplan(timestamp, interval) RETURNS timestamp
 AS 'DECLARE result timestamp;
     BEGIN
         result := $1;
         LOOP
             IF result > now() THEN EXIT; END IF;
             result := result + $2;
         END LOOP;
         RETURN result;
     END;
    '
 LANGUAGE PLPGSQL STABLE STRICT
;
COMMENT ON FUNCTION trunextplan(timestamp, interval) IS '     ';

CREATE OR REPLACE RULE "cipa" AS ON INSERT TO "cipa in" DO NOTIFY "cipa";
#perform
CREATE OR REPLACE FUNCTION "cipa trigger"() RETURNS trigger
 AS 'BEGIN NOTIFY "cipa"; RETURN NULL; END;'
 LANGUAGE PLPGSQL
;
COMMENT ON FUNCTION "cipa trigger"() IS ' NOTIFY cipa';
#perform
CREATE TRIGGER "cipa"
 AFTER UPDATE ON "cipa in" FOR EACH STATEMENT
 EXECUTE PROCEDURE "cipa trigger"()
;
COMMENT ON TRIGGER cipa ON "cipa in" IS ' NOTIFY cipa   cipa in';
